/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/


#ifndef LIST_H_INCLUDED
#define LIST_H_INCLUDED 1

#include "pointer.h"

template<typename Data> class CList {
public:
	struct Node 
	{
		Data	Item;
		Node* Previous;
		Node(): Previous(0) { }
	};
	Node	*iLast;
	
	Node* AppendL(Data Item) 
	{
		Node* np=new (ELeave) Node;
		auto_ptr<Node> n(np);
		n->Item=Item;
		if (iLast) 
		{
			n->Previous=iLast;
		} 
		else 
		{
			n->Previous=NULL;
		}
		iLast = n.release();
		return iLast;
	}
	
	static CList* NewL() 
	{
		auto_ptr<CList> self(new (ELeave) CList);
		self->ConstructL();
		return self.release();
	}

	~CList() 
	{
		reset();
	}
	
	void reset() 
	{
		
		while (iLast!=0)
		{
			Node* tmp = iLast->Previous;
			delete iLast;
			iLast = tmp;
		}
	
		iLast=0;
	}
	
	void DeleteLast() 
	{
		if (!iLast) return;
		Node* tmp=iLast;
		iLast=tmp->Previous;
		delete tmp;
	}

private:
	CList() : iLast(0) { }
	void ConstructL() { }
};
#endif
